//---------------------------------------------------------------------------
//
// Name:        GroundEditorFrm.h
// Author:      i-saint
// Created:     2005/04/19 8:12:12
//
//---------------------------------------------------------------------------
#ifndef __GroundEditorFrm_HPP_
#define __GroundEditorFrm_HPP_

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif


//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/menu.h>
#include <wx/button.h>
#include <wx/statline.h>
#include <wx/spinctrl.h>
#include <wx/combobox.h>
#include <wx/checkbox.h>
#include <wx/radiobut.h>
#include <wx/slider.h>
#include <wx/stattext.h>
#include <wx/statbox.h>
#include <wx/notebook.h>
#include <wx/panel.h>
#include <wx/statusbr.h>
////Header Include End

#include <wx/frame.h>
#include <wx/glcanvas.h>
#include <wx/image.h>

////Dialog Style Start
	#define THIS_DIALOG_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX |  wxCLOSE_BOX
////Dialog Style End

class GroundEditorFrm : public wxFrame
{
private:
    DECLARE_EVENT_TABLE()
public:
    GroundEditorFrm( wxWindow *parent, wxWindowID id = 1, const wxString &title = _T("GroundEditor"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = THIS_DIALOG_STYLE);
    virtual ~GroundEditorFrm();
public:
  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxMenuBar *WxMenuBar1;
	wxSlider *SLCamera;
	wxButton *BUTexHeight;
	wxButton *BUTexSquare;
	wxStaticText *WxStaticText6;
	wxButton *BUTexture;
	wxCheckBox *CKGTexture;
	wxCheckBox *CHKLighting;
	wxCheckBox *CHKPoint;
	wxCheckBox *CHKLine;
	wxCheckBox *CHKPolygon;
	wxStaticBox *draw;
	wxPanel *WxNoteBookPage3;
	wxStaticLine *WxStaticLine3;
	wxStaticLine *WxStaticLine2;
	wxStaticLine *WxStaticLine1;
	wxRadioButton *RBUVV;
	wxRadioButton *RBUVU;
	wxStaticText *WxStaticText7;
	wxStaticText *WxStaticText5;
	wxStaticText *WxStaticText2;
	wxSpinCtrl *SPAttr;
	wxStaticText *WxStaticText1;
	wxComboBox *CBBrushType;
	wxCheckBox *CKAutoUV;
	wxRadioButton *RBFlat;
	wxRadioButton *RBDown;
	wxRadioButton *RBUp;
	wxSlider *SLStrength;
	wxSlider *SLWidth;
	wxStaticText *WxStaticText4;
	wxStaticText *WxStaticText3;
	wxStaticBox *SBBrush;
	wxPanel *WxNoteBookPage1;
	wxNotebook *WxNotebook1;
	wxPanel *minimap_panel;
	wxPanel *ground_panel;
	wxPanel *WxPanel1;
	wxStatusBar *WxStatusBar1;
  ////GUI Control Declaration End


public:
	enum {
		ID_GROUND_CANVAS = 5000,
		ID_MINIMAP_CANVAS,
	};

	void CreateGLWidgets();
	void Draw();
	bool Open();
	bool Save();
	bool SaveAs();
	void GroundCanvasMouse(wxMouseEvent&);
	void MinimapCanvasMouse(wxMouseEvent&);
	void CBBrushTypeCombo(wxCommandEvent&);

	wxString filename;
	wxGLCanvas *ground_canvas;
	wxGLCanvas *minimap_canvas;


public:
	//Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
	//It may replace a numeric value in the enums names.
	enum {
////GUI Enum Control ID Start
wxID_FILE1 = 1036 ,
wxID_OPEN = 1037 ,
wxID_SAVE = 1038 ,
wxID_SAVEAS = 1039 ,
ID_MNU_SAVEASTEXTURE_1112 = 1112 ,
ID_MNU_EDIT_1080 = 1080 ,
ID_MNU_Canvas_1081 = 1081 ,
ID_MNU_SCALE_1083 = 1083 ,
ID_MNU_SUBMENUITEM9_1085 = 1085 ,

ID_SLCAMERA = 1094 ,
ID_BUTEXHEIGHT = 1079 ,
ID_BUTEXSQUARE = 1078 ,
ID_WXSTATICTEXT6 = 1077 ,
ID_BUTEXTURE = 1076 ,
ID_CKGTEXTURE = 1074 ,
ID_CHKLIGHTING = 1066 ,
ID_CHKPOINT = 1063 ,
ID_CHKLINE = 1062 ,
ID_CHKPOLYGON = 1061 ,
ID_DRAW = 1065 ,
ID_WXNOTEBOOKPAGE3 = 1060 ,
ID_WXSTATICLINE3 = 1111 ,
ID_WXSTATICLINE2 = 1110 ,
ID_WXSTATICLINE1 = 1109 ,
ID_RBUVV = 1108 ,
ID_RBUVU = 1107 ,
ID_WXSTATICTEXT7 = 1106 ,
ID_WXSTATICTEXT5 = 1105 ,
ID_WXSTATICTEXT2 = 1104 ,
ID_SPATTR = 1103 ,
ID_WXSTATICTEXT1 = 1102 ,
ID_CBBRUSHTYPE = 1101 ,
ID_CKAUTOUV = 1096 ,
ID_RBFLAT = 1055 ,
ID_RBDOWN = 1054 ,
ID_RBUP = 1053 ,
ID_SLSTRENGTH = 1052 ,
ID_SLWIDTH = 1051 ,
ID_WXSTATICTEXT4 = 1050 ,
ID_WXSTATICTEXT3 = 1049 ,
ID_SBBRUSH = 1043 ,
ID_WXNOTEBOOKPAGE1 = 1041 ,
ID_VIEW = 1040 ,
ID_MINIMAP_PANEL = 1031 ,
ID_GROUND_PANEL = 1014 ,
ID_WXPANEL1 = 1016 ,
ID_WXSTATUSBAR1 = 1001 ,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum
public:
    void GroundEditorFrmClose(wxCloseEvent& event);
    void CreateGUIControls(void);
	void RBUpClick(wxCommandEvent&);
	void RBDownClick(wxCommandEvent&);
	void RBFlatClick(wxCommandEvent&);
	void SLWidthScroll(wxScrollEvent& event);
	void SLStrengthScroll(wxScrollEvent& event);
	void WxopenClick(wxCommandEvent& event);
	void WxsaveClick(wxCommandEvent& event);
	void WxsaveasClick(wxCommandEvent& event);
	void CHKPointClick(wxCommandEvent& event);
	void CHKLineClick(wxCommandEvent& event);
	void CHKPolygonClick(wxCommandEvent& event);
	void CHKLightingClick(wxCommandEvent& event);
	void GroundEditorFrmIdle(wxIdleEvent& event);
	void GroundEditorFrmPaint(wxPaintEvent& event);
	void CKGTextureClick(wxCommandEvent& event);
	void BUTextureClick(wxCommandEvent& event);
	void BUTexSquareClick(wxCommandEvent& event);
	void BUTexHeightClick(wxCommandEvent& event);
	void MNCanvasClick(wxCommandEvent& event);
	void MNScaleClick(wxCommandEvent& event);
	void MNUVRangeClick(wxCommandEvent& event);
	void SLCameraScroll(wxScrollEvent& event);
	void CKAutoUVClick(wxCommandEvent& event);
	void SPAttrUpdated(wxCommandEvent& event);
	void RBUVUClick(wxCommandEvent& event);
	void RBUVVClick(wxCommandEvent& event);
	void GroundEditorFrmKeyDown(wxKeyEvent& event);
	void MNSaveAsTextureClick(wxCommandEvent& event);
};

#endif
 
 
 
 
