#include "GroundEditorFrm.h"



class GroundCanvas : public wxGLCanvas
{
private:
	DECLARE_EVENT_TABLE()

public:
	GroundCanvas(GroundEditorFrm* f, wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style=0, const wxString& name="GLCanvas", int* attribList = 0, const wxPalette& palette = wxNullPalette)
		: wxGLCanvas(parent, id, pos, size, style, name, attribList, palette), frm(f) {}
	void GroundCanvasMouse(wxMouseEvent& e) { frm->GroundCanvasMouse(e); }
	GroundEditorFrm *frm;
};




class MinimapCanvas : public wxGLCanvas
{
private:
	DECLARE_EVENT_TABLE()

public:
	MinimapCanvas(GroundEditorFrm* f, wxWindow* parent, wxGLContext* sharedContext, wxWindowID id, const wxPoint& pos, const wxSize& size, long style=0, const wxString& name="GLCanvas", int* attribList = 0, const wxPalette& palette = wxNullPalette)
		: wxGLCanvas(parent, sharedContext, id, pos, size, style, name, attribList, palette), frm(f) {}
	void MinimapCanvasMouse(wxMouseEvent& e) { frm->MinimapCanvasMouse(e); }
	GroundEditorFrm *frm;
};




BEGIN_EVENT_TABLE(GroundCanvas, wxGLCanvas)
	EVT_MOUSE_EVENTS(GroundCanvas::GroundCanvasMouse)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MinimapCanvas, wxGLCanvas)
	EVT_MOUSE_EVENTS(MinimapCanvas::MinimapCanvasMouse)
END_EVENT_TABLE()


