#ifndef DSO_INCLUDE
#define DSO_INCLUDE

#include <string>

#ifdef _WIN32
	#include <windows.h>
#endif


namespace ist {
	class DynamicSharedObject
	{
	public:
		DynamicSharedObject();
		DynamicSharedObject(const std::string& filename);
		~DynamicSharedObject();
		bool load(const std::string& filename);
		void unload();
		void* getFunction(const std::string& funcname) const;
		const std::string& getFilename() const;
		bool operator!() const;

	private:
		std::string filename;
#ifdef _WIN32
		HMODULE handle;
#endif
#ifdef linux
		void *handle;
#endif
	};

	typedef DynamicSharedObject DSO;
} // ist

#endif
