#include "gl_include.h"
#include "gl_polygon_model.h"
using namespace std;

#if defined(ENABLE_GL_EXT) && defined(ENABLE_ARB_VBO)
	#define _ENABLE_ARB_VBO
	#define BUFFER_OFFSET(i) ((char*)0 + (i))
#endif





namespace ist {
namespace i3d {





PolygonChunc::PolygonChunc()
	: vbo_id(0)
{}

PolygonChunc::~PolygonChunc()
{}

void PolygonChunc::setup()
{
	BPolygonChunc::setup();

	if(vvtx_array.empty()) {
		vvtx_array.reserve(idx_array.size());
		for(unsigned int i=0; i<idx_array.size(); ++i) {
			vvtx_array.push_back( vector3(vtx_array[idx_array[i]].v) );
		}
	}

	vertex_array.resize(vvtx_array.size()*3+vnml_array.size()*3+tex_array.size()*2);

	size_t offset = 0;
	for(size_t i=0; i<vvtx_array.size(); ++i) {
		vertex_array[i*3+0] = vvtx_array[i].x;
		vertex_array[i*3+1] = vvtx_array[i].y;
		vertex_array[i*3+2] = vvtx_array[i].z;
	}
	offset+=vvtx_array.size()*3;

	for(size_t i=0; i<vnml_array.size(); ++i) {
		vertex_array[offset+i*3+0] = vnml_array[i].x;
		vertex_array[offset+i*3+1] = vnml_array[i].y;
		vertex_array[offset+i*3+2] = vnml_array[i].z;
	}
	offset+=vnml_array.size()*3;

	if(!tex_array.empty()) {
		for(size_t i=0; i<tex_array.size(); ++i) {
			vertex_array[offset+i*2+0] = tex_array[i].x;
			vertex_array[offset+i*2+1] = tex_array[i].y;
		}
	}
	else {
		for(size_t i=0; i<tex_array.size(); ++i) {
			vertex_array[offset+i*2+0] = 0;
			vertex_array[offset+i*2+1] = 0;
		}
	}

	vvertex_cont().swap(vvtx_array);
/*
#ifdef _ENABLE_ARB_VBO
	glGenBuffersARB(1, &vbo_id);
	glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo_id);
	glBufferDataARB(GL_ARRAY_BUFFER_ARB, idx_array.size()*8*sizeof(float), vertex_pointer, GL_STATIC_DRAW_ARB);
#endif
*/
}


void PolygonChunc::draw() const
{
/*
#ifdef _ENABLE_ARB_VBO
	if(vbo_id!=0) {
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, vbo_id);
		glVertexPointer(3, GL_FLOAT, 0, 0);
		glNormalPointer(GL_FLOAT, 0, BUFFER_OFFSET(idx_array.size()*3*sizeof(float)) );
		glTexCoordPointer(2, GL_FLOAT, 0, BUFFER_OFFSET(idx_array.size()*6*sizeof(float)) );
	}
#endif
*/

	const float *vertex_pointer = &vertex_array[0];
	glVertexPointer(3, GL_FLOAT, 0, vertex_pointer);
	glNormalPointer(GL_FLOAT, 0, vertex_pointer+num_face*3*3 );
	glTexCoordPointer(2, GL_FLOAT, 0, vertex_pointer+num_face*3*6 );

	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glDrawArrays(GL_TRIANGLES, 0, num_face*3);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);
	glDisableClientState(GL_VERTEX_ARRAY);
}


IPolygonModel* IPolygonModel::create() { return new PolygonModel(); }


}	// gl
}	// ist


