#ifndef I3D_LIGHT_INCLUDE
#define I3D_LIGHT_INCLUDE

#include "vector.h"
#include "rgba.h"



namespace ist {
namespace i3d {


class Light
{
private:
	Light(const Light&);
	Light& operator=(const Light&);

public:
	Light();
	~Light();

	void enable() const;
	void disable() const;
	bool isValid() const;

public:
	vector4 position;
	vector4 ambient;
	vector4 diffuse;
	vector4 specular;
};


class Fog
{
public:
	Fog();
	~Fog();

	void enable() const;
	void disable() const;

public:
	vector4 position;
	vector4 color;
	float start;
	float end;
};


} //gl
} //ist

#endif
